> ## Documentation Index
> Fetch the complete documentation index at: https://devdocs.xbox.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Grant Character To User

> Grants the specified character type to the user. CharacterIds are not globally unique; characterId must be evaluated with the parent PlayFabId to guarantee uniqueness.



## OpenAPI

````yaml /services/playfab/api-references/rest/server/server.openapi.json post /Server/GrantCharacterToUser
openapi: 3.0.0
info:
  version: '260922'
  title: PlayFab Server API
  description: >-
    Provides functionality to allow external (developer-controlled) servers to
    interact with user inventories and data in a trusted manner, and to handle
    matchmaking and client connection orchestration
  termsOfService: https://playfab.com/terms/
  contact:
    url: https://community.playfab.com/index.html
  license:
    name: Apache 2.0
    url: https://github.com/PlayFab/API_Specs/blob/master/LICENSE
servers:
  - url: https://{titleId}.playfabapi.com
    description: PlayFab title endpoint
    variables:
      titleId:
        default: your_title_id
        description: Your PlayFab title ID (hex).
security: []
tags:
  - name: Account Management
    description: Account Management APIs
  - name: Analytics
    description: Analytics APIs
  - name: Authentication
    description: Authentication APIs
  - name: Character Data
    description: Character Data APIs
  - name: Characters
    description: Characters APIs
  - name: Content
    description: Content Service APIs
  - name: Friend List Management
    description: Friend List Management APIs
  - name: Matchmaking
    description: Matchmaking APIs
  - name: Platform Specific Methods
    description: Platform Specific Methods APIs
  - name: Player Data Management
    description: Player Data Management APIs
  - name: Player Item Management
    description: Player Item Management APIs
  - name: PlayStream
    description: PlayStream Management APIs
  - name: Server-Side Cloud Script
    description: Server-Side Cloud Script APIs
  - name: Shared Group Data
    description: Shared Group Data APIs
  - name: Title-Wide Data Management
    description: Title-Wide Data Management APIs
paths:
  /Server/GrantCharacterToUser:
    post:
      tags:
        - Characters
      summary: Grant Character To User
      description: >-
        Grants the specified character type to the user. CharacterIds are not
        globally unique; characterId must be evaluated with the parent PlayFabId
        to guarantee uniqueness.
      operationId: GrantCharacterToUser
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/GrantCharacterToUserRequest'
        description: >-
          Grants a character to the user of the type and name specified in the
          request.
      responses:
        '200':
          $ref: '#/components/responses/GrantCharacterToUserResult'
        '400':
          $ref: '#/components/responses/ApiErrorWrapper'
      security:
        - SecretKey: []
components:
  schemas:
    GrantCharacterToUserRequest:
      description: >-
        Grants a character to the user of the type and name specified in the
        request.
      type: object
      properties:
        CharacterName:
          description: >-
            Non-unique display name of the character being granted (1-40
            characters in length).
          type: string
        CharacterType:
          description: >-
            Type of the character being granted; statistics can be sliced based
            on this value.
          type: string
        CustomTags:
          description: >-
            The optional custom tags associated with the request (e.g. build
            number, external trace identifiers, etc.).
          type: object
        PlayFabId:
          description: >-
            Unique PlayFab assigned ID of the user on whom the operation will be
            performed.
          type: string
      required:
        - PlayFabId
        - CharacterName
        - CharacterType
      example:
        PlayFabId: '20394883567'
        CharacterName: FighterDude
        CharacterType: Blue Warrior
    GrantCharacterToUserResult:
      type: object
      properties:
        CharacterId:
          description: Unique identifier tagged to this character.
          type: string
      example:
        CharacterId: '98765432'
    ApiErrorWrapper:
      description: The basic wrapper around every failed API response
      type: object
      properties:
        code:
          description: Numerical HTTP code
          type: integer
        status:
          description: String HTTP code
          type: string
        error:
          description: Playfab error code
          type: string
        errorCode:
          description: Numerical PlayFab error code
          type: integer
        errorMessage:
          description: Description for the PlayFab errorCode
          type: string
        errorDetails:
          description: Detailed description of individual issues with the request object
          type: object
      required:
        - code
        - errorCode
  responses:
    GrantCharacterToUserResult:
      description: ''
      content:
        application/json:
          schema:
            type: object
            properties:
              code:
                type: integer
                description: >-
                  The Http status code. If X-ReportErrorAsSuccess header is set
                  to true, this will report the actual http error code.
              status:
                type: string
                description: The Http status code as a string.
              data:
                $ref: '#/components/schemas/GrantCharacterToUserResult'
            example:
              code: 200
              status: OK
              data:
                CharacterId: '98765432'
    ApiErrorWrapper:
      description: This is the outer wrapper for all responses with errors
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/ApiErrorWrapper'
  securitySchemes:
    SecretKey:
      type: apiKey
      in: header
      name: X-SecretKey
      description: >-
        This API requires a title secret key, available to title admins, from
        PlayFab Game Manager.

````

## Related topics

- [Grant Character To User](/services/playfab/api-references/rest/server/characters/grant-character-to-user.md)
- [Profile Writes Meter API Description](/services/playfab/pricing/meters/profile-writes.md)
- [Grant Items To Character](/services/playfab/api-references/rest/server/player-item-management/grant-items-to-character.md)
- [Grant Items To Users](/services/playfab/api-references/rest/server/player-item-management/grant-items-to-users.md)
- [Grant Items To User](/services/playfab/api-references/rest/server/player-item-management/grant-items-to-user.md)
